# Class ListView

java.lang.Object
javax.swing.text.View
javax.swing.text.CompositeView
javax.swing.text.BoxView
javax.swing.text.html.BlockView
javax.swing.text.html.ListView

All Implemented Interfaces:
  `SwingConstants`

public class ListView extends BlockView
A view implementation to display an html list

## Field Summary

### Fields declared in class View

`BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`
Modifier and Type
Field
Description
`static final int`
`BadBreakWeight`
The weight to indicate a view is a bad break opportunity for the purpose of formatting.
`static final int`
`ExcellentBreakWeight`
The weight to indicate a view supports breaking, and this represents a very attractive place to break.
`static final int`
`ForcedBreakWeight`
The weight to indicate a view supports breaking, and must be broken to be represented properly when placed in a view that formats its children by breaking them.
`static final int`
`GoodBreakWeight`
The weight to indicate a view supports breaking, but better opportunities probably exist.
`static final int`
`X_AXIS`
Axis for format/break operations.
`static final int`
`Y_AXIS`
Axis for format/break operations.

### Fields declared in interface SwingConstants

`BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`
Modifier and Type
Field
Description
`static final int`
`BOTTOM`
Box-orientation constant used to specify the bottom of a box.
`static final int`
`CENTER`
The central position in an area.
`static final int`
`EAST`
Compass-direction east (right).
`static final int`
`HORIZONTAL`
Horizontal orientation.
`static final int`
`LEADING`
Identifies the leading edge of text for use with left-to-right and right-to-left languages.
`static final int`
`LEFT`
Box-orientation constant used to specify the left side of a box.
`static final int`
`NEXT`
Identifies the next direction in a sequence.
`static final int`
`NORTH`
Compass-direction North (up).
`static final int`
`NORTH_EAST`
Compass-direction north-east (upper right).
`static final int`
`NORTH_WEST`
Compass-direction north west (upper left).
`static final int`
`PREVIOUS`
Identifies the previous direction in a sequence.
`static final int`
`RIGHT`
Box-orientation constant used to specify the right side of a box.
`static final int`
`SOUTH`
Compass-direction south (down).
`static final int`
`SOUTH_EAST`
Compass-direction south-east (lower right).
`static final int`
`SOUTH_WEST`
Compass-direction south-west (lower left).
`static final int`
`TOP`
Box-orientation constant used to specify the top of a box.
`static final int`
`TRAILING`
Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
`static final int`
`VERTICAL`
Vertical orientation.
`static final int`
`WEST`
Compass-direction west (left).

## Constructor Summary

Constructors
Constructor
Description
`ListView(Element elem)`
Creates a new view that represents a list element.

## Method Summary

Modifier and Type
Method
Description
`float`
`getAlignment(int axis)`
Calculates the desired shape of the list.
`void`
`paint(Graphics g, Shape allocation)`
Renders using the given rendering surface and area on that surface.
`protected void`
`paintChild(Graphics g, Rectangle alloc, int index)`
Paints one of the children; called by paint().

### Methods declared in class BlockView

`calculateMajorAxisRequirements, calculateMinorAxisRequirements, getAttributes, getMaximumSpan, getMinimumSpan, getPreferredSpan, getResizeWeight, getStyleSheet, layoutMinorAxis, setParent, setPropertiesFromAttributes`
Modifier and Type
Method
Description
`protected SizeRequirements`
`calculateMajorAxisRequirements(int axis, SizeRequirements r)`
Calculate the requirements of the block along the major axis (i.e. the axis along with it tiles).
`protected SizeRequirements`
`calculateMinorAxisRequirements(int axis, SizeRequirements r)`
Calculate the requirements of the block along the minor axis (i.e. the axis orthogonal to the axis along with it tiles).
`AttributeSet`
`getAttributes()`
Fetches the attributes to use when rendering.
`float`
`getMaximumSpan(int axis)`
Determines the maximum span for this view along an axis.
`float`
`getMinimumSpan(int axis)`
Determines the minimum span for this view along an axis.
`float`
`getPreferredSpan(int axis)`
Determines the preferred span for this view along an axis.
`int`
`getResizeWeight(int axis)`
Gets the resize weight.
`protected StyleSheet`
`getStyleSheet()`
Convenient method to get the StyleSheet.
`protected void`
`layoutMinorAxis(int targetSpan, int axis, int[] offsets, int[] spans)`
Performs layout for the minor axis of the box (i.e. the axis orthogonal to the axis that it represents).
`void`
`setParent(View parent)`
Establishes the parent view for this view.
`protected void`
`setPropertiesFromAttributes()`
Update any cached values that come from attributes.

### Methods declared in class BoxView

`baselineLayout, baselineRequirements, childAllocation, flipEastAndWestAtEnds, forwardUpdate, getAxis, getChildAllocation, getHeight, getOffset, getSpan, getViewAtPoint, getWidth, isAfter, isAllocationValid, isBefore, isLayoutValid, layout, layoutChanged, layoutMajorAxis, modelToView, preferenceChanged, replace, setAxis, setSize, viewToModel`
Modifier and Type
Method
Description
`protected void`
`baselineLayout(int targetSpan, int axis, int[] offsets, int[] spans)`
Computes the location and extent of each child view in this `BoxView` given the `targetSpan`, which is the width (or height) of the region we have to work with.
`protected SizeRequirements`
`baselineRequirements(int axis, SizeRequirements r)`
Calculates the size requirements for this `BoxView` by examining the size of each child view.
`protected void`
`childAllocation(int index, Rectangle alloc)`
Allocates a region for a child view.
`protected boolean`
`flipEastAndWestAtEnds(int position, Position.Bias bias)`
Determines in which direction the next view lays.
`protected void`
`forwardUpdate(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a, ViewFactory f)`
Forwards the given `DocumentEvent` to the child views that need to be notified of the change to the model.
`int`
`getAxis()`
Fetches the tile axis property.
`Shape`
`getChildAllocation(int index, Shape a)`
Fetches the allocation for the given child view.
`int`
`getHeight()`
Returns the current height of the box.
`protected int`
`getOffset(int axis, int childIndex)`
Fetches the offset of a particular child's current layout.
`protected int`
`getSpan(int axis, int childIndex)`
Fetches the span of a particular child's current layout.
`protected View`
`getViewAtPoint(int x, int y, Rectangle alloc)`
Fetches the child view at the given coordinates.
`int`
`getWidth()`
Returns the current width of the box.
`protected boolean`
`isAfter(int x, int y, Rectangle innerAlloc)`
Determines if a point falls after an allocated region.
`protected boolean`
`isAllocationValid()`
Are the allocations for the children still valid?
`protected boolean`
`isBefore(int x, int y, Rectangle innerAlloc)`
Determines if a point falls before an allocated region.
`protected boolean`
`isLayoutValid(int axis)`
Determines if the layout is valid along the given axis.
`protected void`
`layout(int width, int height)`
Perform layout on the box
`void`
`layoutChanged(int axis)`
Invalidates the layout along an axis.
`protected void`
`layoutMajorAxis(int targetSpan, int axis, int[] offsets, int[] spans)`
Performs layout for the major axis of the box (i.e. the axis that it represents).
`Shape`
`modelToView(int pos, Shape a, Position.Bias b)`
Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
`void`
`preferenceChanged(View child, boolean width, boolean height)`
This is called by a child to indicate its preferred span has changed.
`void`
`replace(int index, int length, View[] elems)`
Invalidates the layout and resizes the cache of requests/allocations.
`void`
`setAxis(int axis)`
Sets the tile axis property.
`void`
`setSize(float width, float height)`
Sets the size of the view.
`int`
`viewToModel(float x, float y, Shape a, Position.Bias[] bias)`
Provides a mapping from the view coordinate space to the logical coordinate space of the model.

### Methods declared in class CompositeView

`getBottomInset, getInsideAllocation, getLeftInset, getNextEastWestVisualPositionFrom, getNextNorthSouthVisualPositionFrom, getNextVisualPositionFrom, getRightInset, getTopInset, getView, getViewAtPosition, getViewCount, getViewIndex, getViewIndexAtPosition, loadChildren, modelToView, setInsets, setParagraphInsets`
Modifier and Type
Method
Description
`protected short`
`getBottomInset()`
Gets the bottom inset.
`protected Rectangle`
`getInsideAllocation(Shape a)`
Translates the immutable allocation given to the view to a mutable allocation that represents the interior allocation (i.e. the bounds of the given allocation with the top, left, bottom, and right insets removed.
`protected short`
`getLeftInset()`
Gets the left inset.
`protected int`
`getNextEastWestVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
Returns the next visual position for the cursor, in either the east or west direction.
`protected int`
`getNextNorthSouthVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
Returns the next visual position for the cursor, in either the north or south direction.
`int`
`getNextVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
Provides a way to determine the next visually represented model location that one might place a caret.
`protected short`
`getRightInset()`
Gets the right inset.
`protected short`
`getTopInset()`
Gets the top inset.
`View`
`getView(int n)`
Returns the n-th view in this container.
`protected View`
`getViewAtPosition(int pos, Rectangle a)`
Fetches the child view that represents the given position in the model.
`int`
`getViewCount()`
Returns the number of child views of this view.
`int`
`getViewIndex(int pos, Position.Bias b)`
Returns the child view index representing the given position in the model.
`protected int`
`getViewIndexAtPosition(int pos)`
Fetches the child view index representing the given position in the model.
`protected void`
`loadChildren(ViewFactory f)`
Loads all of the children to initialize the view.
`Shape`
`modelToView(int p0, Position.Bias b0, int p1, Position.Bias b1, Shape a)`
Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
`protected void`
`setInsets(short top, short left, short bottom, short right)`
Sets the insets for the view.
`protected void`
`setParagraphInsets(AttributeSet attr)`
Sets the insets from the paragraph attributes specified in the given attributes.

### Methods declared in class View

`append, breakView, changedUpdate, createFragment, forwardUpdateToView, getBreakWeight, getContainer, getDocument, getElement, getEndOffset, getGraphics, getParent, getStartOffset, getToolTipText, getViewFactory, getViewIndex, insert, insertUpdate, isVisible, modelToView, remove, removeAll, removeUpdate, updateChildren, updateLayout, viewToModel`
Modifier and Type
Method
Description
`void`
`append(View v)`
Appends a single child view.
`View`
`breakView(int axis, int offset, float pos, float len)`
Tries to break this view on the given axis.
`void`
`changedUpdate(DocumentEvent e, Shape a, ViewFactory f)`
Gives notification from the document that attributes were changed in a location that this view is responsible for.
`View`
`createFragment(int p0, int p1)`
Creates a view that represents a portion of the element.
`protected void`
`forwardUpdateToView(View v, DocumentEvent e, Shape a, ViewFactory f)`
Forwards the `DocumentEvent` to the give child view.
`int`
`getBreakWeight(int axis, float pos, float len)`
Determines how attractive a break opportunity in this view is.
`Container`
`getContainer()`
Fetches the container hosting the view.
`Document`
`getDocument()`
Fetches the model associated with the view.
`Element`
`getElement()`
Fetches the structural portion of the subject that this view is mapped to.
`int`
`getEndOffset()`
Fetches the portion of the model for which this view is responsible.
`Graphics`
`getGraphics()`
Fetch a `Graphics` for rendering.
`View`
`getParent()`
Returns the parent of the view.
`int`
`getStartOffset()`
Fetches the portion of the model for which this view is responsible.
`String`
`getToolTipText(float x, float y, Shape allocation)`
Returns the tooltip text at the specified location.
`ViewFactory`
`getViewFactory()`
Fetches the `ViewFactory` implementation that is feeding the view hierarchy.
`int`
`getViewIndex(float x, float y, Shape allocation)`
Returns the child view index representing the given position in the view.
`void`
`insert(int offs, View v)`
Inserts a single child view.
`void`
`insertUpdate(DocumentEvent e, Shape a, ViewFactory f)`
Gives notification that something was inserted into the document in a location that this view is responsible for.
`boolean`
`isVisible()`
Returns a boolean that indicates whether the view is visible or not.
`Shape`
`modelToView(int pos, Shape a)`
Deprecated.
`void`
`remove(int i)`
Removes one of the children at the given position.
`void`
`removeAll()`
Removes all of the children.
`void`
`removeUpdate(DocumentEvent e, Shape a, ViewFactory f)`
Gives notification that something was removed from the document in a location that this view is responsible for.
`protected boolean`
`updateChildren(DocumentEvent.ElementChange ec, DocumentEvent e, ViewFactory f)`
Updates the child views in response to receiving notification that the model changed, and there is change record for the element this view is responsible for.
`protected void`
`updateLayout(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a)`
Updates the layout in response to receiving notification of change from the model.
`int`
`viewToModel(float x, float y, Shape a)`
Deprecated.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### ListView

public ListView(Element elem)
Creates a new view that represents a list element.

Parameters:
  `elem` - the element to create a view for

## Method Details

### getAlignment

public float getAlignment(int axis)
Calculates the desired shape of the list.

Overrides:
  `getAlignment` in class `BlockView`
Parameters:
  `axis` - may be either X_AXIS or Y_AXIS
Returns:
  the desired span
See Also:
  - `View.getPreferredSpan(int)`

### paint

public void paint(Graphics g, Shape allocation)
Renders using the given rendering surface and area on that surface.

Overrides:
  `paint` in class `BlockView`
Parameters:
  `g` - the rendering surface to use
  `allocation` - the allocated region to render into
See Also:
  - `View.paint(Graphics, Shape)`

### paintChild

protected void paintChild(Graphics g, Rectangle alloc, int index)
Paints one of the children; called by paint(). By default that is all it does, but a subclass can use this to paint things relative to the child.

Overrides:
  `paintChild` in class `BoxView`
Parameters:
  `g` - the graphics context
  `alloc` - the allocated region to render the child into
  `index` - the index of the child